import { Component, EventEmitter, Input, Output } from '@angular/core';

@Component({
  selector: 'app-input',
  templateUrl: './input.component.html',
  styleUrls: ['./input.component.scss'],
})
export class InputV3Component {
  /** HTML id associated with for */
  @Input() id: string;

  @Input() type: 'text' | 'password' = 'text';

  @Input() disabled?: boolean = false;

  /** Label for the radio */
  @Input() label?: string;

  /** Additional label description */
  @Input() description?: string;

  /** What additional data should be displayed ? */
  @Input() status?: 'error' | 'success' | 'info' | 'warning';

  /** Additional text to display */
  @Input() statusText?: string;

  /** Value */
  @Input() value: string = '';

  @Output() valueChange = new EventEmitter<Event>();

  public onValueChange(event: Event) {
    this.valueChange.emit(event);
  }
}
